image: docker:latest
services:
  - docker:dind

variables:
  DOCKER_DRIVER: overlay

stages:
  - build
  - test
  - package

cache:
  paths:
    - node_modules/

install_dependencies:
  stage: build
  image: node:latest
  script:
    - npm install
  artifacts:
    paths:
      - node_modules/

test_with_lab:
  stage: test
  image: node:latest
  script: npm test
  
package_to_docker_image:
  stage: package
  script:
  - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN registry.gitlab.com
  - docker build -t registry.gitlab.com/m.hardwork/example-ci .
  - docker push registry.gitlab.com/m.hardwork/example-ci
